{--------------------------------------------------------}
{                                                        }
{    Radio50 - Executor interativo de streams de udio   }
{                                                        }
{    Busca rdios em www.radios.com                      }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em fevereiro/2018                                   }
{                                                        }
{--------------------------------------------------------}

unit rdBusca_antiga;

interface
uses
    windows,
    dvcrt,
    dvwin,
    dvForm,
    sysUtils,
    rdmsg,
    rdvars,
    rdDownld,
    rdBass,
    rdFFplay,
    Classes;

procedure buscaRadiosTop;

implementation

uses rdproces;

function buscaInfoRadio (nome, siteRadiosCom: string): string;
var
    slr: TStringList;
    site: string;
    i, j, k, p: integer;
label achou;
begin
    slr := TStringList.Create;
    rdDownld.BaixaStringList(siteRadiosCom, slr);
    site := '';

    // busca de tipo 1
    for i := 0 to slr.count-3 do
        if pos ('if(withFlash){', slr[i]) <> 0 then
            for j := i+1 to slr.count-3 do
                if pos ('}else{', slr[j]) <> 0 then
                    for k := j+1 to slr.count-3 do
                        if pos ('src:  ', slr[k]) <> 0 then
                            begin
                                site := slr[k];
                                delete (site, 1, pos('"', site));
                                delete (site, pos('"', site), 999);
                                if (site <> '') and (site[length(site)] = ';') then
                                    delete (site, length(site), 1);
                                goto achou;
                            end;

    // busca de tipo 2
    for i := 0 to slr.count-3 do
        if pos ('''url'':''', slr[i]) <> 0 then
            begin
                site := slr[i];
                delete (site, 1, pos ('http', site)-1);
                p := pos (',', site);
                if p <> 0 then delete (site, p, 99);
                p := pos ('''', site);
                if p <> 0 then delete (site, p, 99);
                p := pos ('"', site);
                if p <> 0 then delete (site, p, 99);
                goto achou;
            end;

    // busca de tipo 3
    for i := 0 to slr.count-3 do
        if pos ('flowplayer(', slr[i]) <> 0 then
        begin
            for j := i+1 to slr.count-3 do
                if pos ('ipadUrl: "', slr[j]) <> 0 then
                    begin
                        site := slr[j];
                        delete (site, 1, pos ('http', site)-1);
                        delete (site, pos ('"', site), 99);
                        goto achou;
                    end;

            for j := i+1 to slr.count-3 do
                if pos ('netConnectionUrl:', slr[j]) <> 0 then
                    begin
                        site := slr[j];
                        delete (site, 1, pos ('"', site));
                        delete (site, pos ('"', site), 99);
                        goto achou;
                    end;

            for j := i+1 to slr.count-3 do
                if pos ('clip: {', slr[j]) <> 0 then
                    begin
                        site := slr[j+1];
                        delete (site, 1, pos ('"', site));
                        delete (site, pos ('"', site), 99);
                        goto achou;
                    end;
        end;

achou:
    result := trim(site);
    slr.Free;
end;

procedure veSeGuardaRadio (nomeRadio, url: string);
var c: char;
    categ: string;
begin
    limpaBaixo (3);
    mensagem ('RDGUARDA', 0);    {'Quer guardar esta rdio? '}
    c := popupMenuPorLetra('SN');
    if c = 'S' then
        begin
            categ := escolheCategoria;
            if categ <> '' then
                sintGravaAmbienteArq (categ, nomeRadio, url, arqIndice)
            else
                mensagem ('RDDESIST', 1);  {'Desistiu'}
        end;
end;

function limpaNomeRadio (nome: string): string;
begin
    if (copy (nome, 1, 6) = 'Radio ') or (copy (nome, 1, 6) = 'Rdio ') then
        delete (nome, 1, 6);
    result := nome;
end;

procedure escolheRadios (radiosTop, sitesTop: TStringList);
var i, n: integer;
    c1, c2: char;
    url: string;
    ok: boolean;

begin
    n := 0;
    folheiaCria(1, wherey, 50, 24);
    for i := 0 to radiosTop.Count-1 do
        folheiaAdiciona ({limpaNomeRadio}(radiosTop[i]));

    repeat
        clrscr;
        textBackground (BLUE);
        mensagem ('RDRDTOP', 1);       {Rdios TOP}
        textBackground (BLACK);

        textBackground (RED);
        mensagem ('RDESCOLH', 1);      {Escolha uma das rdios}
        textBackground (BLACK);

        folheiaExecuta(n, n, c1, c2, true);
        if ((n < 1) or (n > radiosTop.Count)) and (c1 <> ESC) then
            c1 := ' ';

        limpaBaixo (2);
        if c1 = ENTER then
            begin
                mensagem ('RDLOCRAD', 0);   {Localizando }
                sintWriteln (radiosTop[n-1]);
                writeln (sitesTop[n-1]);
                url := buscaInfoRadio (radiosTop[n-1], sitesTop[n-1]);

                ok := false;
                if url <> '' then
                    begin
                        writeln (url);
                        ultimaTocada := url;
                        if copy (url, 1, 7) <> 'FFMPEG ' then
                            ok := tocaRadioBass (url) >= 0
                        else
                            ok := tocaRadioExterna (trim (copy (url, 8, 999))) >= 0;
                    end;

                if ok then
                    veSeGuardaRadio (radiosTop[n-1], url)
                else
                    begin
                        mensagem ('RDNAOENC', 1);    {'Stream de udio no foi encontrada'}
                        mensagem ('RDAPTENT', 1);    {'Aperte enter...'}
                        readln;
                    end;
            end;

    until (c1 = ESC);
    folheiaDestroi;
end;

procedure ordenaRadios (radiosTop, sitesTop: TStringList);
var i, j: integer;
    salva: string;
begin
    for i := 0 to radiosTop.count-2 do
        for j := i+1 to radiosTop.count-1 do
            begin
                if radiosTop[i] > radiosTop[j] then
                    begin
                        salva := radiosTop[i];
                        radiosTop[i] := radiosTop[j];
                        radiosTop[j] := salva;
                        salva := sitesTop[i];
                        sitesTop[i] := sitesTop[j];
                        sitesTop[j] := salva;
                    end;
            end;
end;

procedure buscaRadiosTop;
var sl, radiosTop, sitesTop: TStringList;
    i: integer;
    s: string;
begin
    clrscr;
    textBackground (BLUE);
    mensagem ('RDRDTOP', 1);       {Rdios TOP}
    textBackground (BLACK);
    mensagem ('RDUMOMEN', 1);      {Um momento, consultando o servidor de rdios'}

    sl := TStringList.Create;
    radiosTop := TStringList.Create;
    sitesTop := TStringList.Create;

    rdDownld.BaixaStringList('https://www.radios.com.br', sl);

    for i := 0 to sl.count-1 do
        if pos ('"panel-title">Top R', sl[i]) <> 0 then break;
    for i := i to sl.count-1 do
        if pos ('<div class="tab-item', sl[i]) <> 0 then break;

    while pos ('<div class="tab-item', sl[i]) <> 0 do
        begin
           i := i + 1;
           s := sl[i];
           delete (s, 1, pos ('alt="', s) + 4);
           s := copy (s, 1, pos('"', s)-1);
           s := UTF8ToAnsi(s);

           radiosTop.add (limpaNomeRadio(s));

           s := sl[i];
           delete (s, 1, pos ('"http', s));
           s := copy (s, 1, pos ('" data-', s)-1);
           sitesTop.add(s);

           i := i + 2;
        end;

    sl.free;

    ordenaRadios (radiosTop, sitesTop);
    escolheRadios (radiosTop, sitesTop);

    radiosTop.free;
    sitesTop.free;
    clrscr;
end;

end.


