{--------------------------------------------------------}
{                                                        }
{    Radio50 - Executor interativo de streams de udio   }
{                                                        }
{    Execua da stream atravs de FFPlay                }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em outubro/2015                                     }
{                                                        }
{--------------------------------------------------------}

unit rdFFPlay;

interface
uses
    windows, dvcrt, dvWin, rdPipeEx, SysUtils, rdmsg;

function tocaRadioExterna (nomeRadio: string): integer;
    
implementation
uses rdBass;

var
    codif, hz, stmono, trans, bitrate: string;

label fim;

{--------------------------------------------------------}
{             extrai informaes da stream
{--------------------------------------------------------}

procedure extraiInfo (retorno: string);

     function extraiAteVirg: string;
     var p: integer;
     begin
         p := pos (',', retorno);
         result := trim (copy (retorno, 1, p-1));
         delete (retorno, 1, p);
     end;

begin
     delete (retorno, 1, pos (':', retorno));
     delete (retorno, 1, pos (':', retorno));
     codif := extraiAteVirg;
     hz := extraiAteVirg;
     stmono := extraiAteVirg;
     trans := extraiAteVirg;
     bitrate := trim (copy (retorno, 1, pos ('s', retorno)+1));
end;

{--------------------------------------------------------}
{              exibe informaes extradas
{--------------------------------------------------------}

procedure exibeInfo;
begin
    mensagem ('RDCODIFC', 0);  {'Codificao: '}
    sintWriteln (codif);
    mensagem ('RDAMOSTR', 0);  {'Amostragem:  '}
    sintWriteln (hz);
    mensagem ('RDCANAIS', 0);  {'Canais:      '}
    sintWriteln (stmono);
    mensagem ('RDTRANSP', 0);  {'Transporte:  '}
    sintWriteln (trans);
    mensagem ('RDTAXAB' , 0);  {'Taxa:        '}
    sintWriteln (bitrate);
end;

{--------------------------------------------------------}
{                     interao
{--------------------------------------------------------}

procedure interage (c: char; nomeRadio: string);
begin
    limpaBufTec;
    case upcase(c) of
        'V': mudaVolumeBass;
        'I': exibeInfo;
        'E': begin
                 mensagem ('RDENDSEL', 1);  {'Endereo selecionado:'}
                 sintWriteln (nomeRadio);
             end;
    else
        mensagem ('RDOPVAL2', 1);  {'Opes vlidas: Informaes, Volume, Endereo'}
    end;
end;

{--------------------------------------------------------}
{               toca rdio com FFPlay
{--------------------------------------------------------}

function tocaRadioExterna (nomeRadio: string): integer;
var
    nomeProgExterno: string;
    s: string;
    c: char;
    p: integer;
begin
    result := 0;
    writeln;
    textBackGround (RED);
    mensagem ('RDFFPLAY', 1);   {'Processando com ffplay'}
    textBackGround (BLACK);

    nomeProgExterno := sintAmbiente ('RADIO50', 'TOCADOR');
    if nomeProgExterno = '' then
        nomeProgExterno := sintAmbiente('DOSVOX', 'PGMDOSVOX') + '\ffplay.exe -nodisp';

    if not pipedProgExecute (nomeProgExterno + ' ' + nomeRadio) then
        begin
            mensagem ('RDERPLYR', 2);  {'No pude executar o tocador externo.'}
            exit;
        end;

    c := ' ';
    repeat
        s := ReadPipeInput(OutputPipeRead);
        if s <> '' then writeln (s);

        keypressed;
        s := ReadPipeInput(ErrorPipeRead);
        if s <> '' then
             begin
                 p := pos ('Stream #', s);
                 if p <> 0 then
                      begin
                          delete (s, 1, p-1);
                          extraiInfo(s);
                      end;
             end;

        if keypressed then
            begin
               c := readkey;
               if c = ^R then
                   begin
                       result := -1;
                       c := ESC;
                   end;
               if c = ^C then
                   putClipboard (pchar(nomeRadio));

               if c <> ESC then
                    interage (c, nomeRadio);
            end;

    until c = ESC;

    while keypressed do readkey;
    pipedProgStop;

end;

end.
