{--------------------------------------------------------}
{                                                        }
{    Radio50 - Executor interativo de streams de udio   }
{                                                        }
{    Processamento de rdios preferidas                  }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em outubro/2015                                     }
{                                                        }
{--------------------------------------------------------}

unit rdPrefer;

interface
uses
    windows,
    dvcrt,
    dvwin,
    dvForm,
    sysUtils,
    rdbass,
    rdFFplay,
    rdmsg,
    rdvars;

procedure radiosPreferidas;

implementation

{--------------------------------------------------------}
{                   escolhe pelo nmero
{--------------------------------------------------------}

procedure escolhePeloNumero;
var r, sn, nomeRadio, url: string;
    p, n, erro: integer;
begin
    mensagem ('RDINFNUM', 0);   {'Informe o nmero da rdio entre 1 e 20'}
    sintReadln (sn);
    val (sn, n, erro);
    if (erro <> 0) or (n <= 0) or (n > 20) then
        begin
             mensagem ('RDNUMINV', 2);  {'Nmero da rdio deve estar entre 1 e 20'}
             mensagem ('RDUSEFF',  1);  {'Use a opo F para descobrir os nmeros.}
             exit;
        end;

    r := sintAmbienteArq ('PREFERIDAS', sn, '', arqIndice);
    p := pos ('=', r);
    if p <= 1 then
        begin
            mensagem ('RDERRRAD',  2);  {'A informao sobre est rdio no est disponvel.}
            exit;
        end;

    nomeRadio := copy (r, 1, p-1);
    url := copy (r, p+1, 999);

    clrScr;
    textBackground (BLUE);
    sintWriteln (nomeRadio);
    textBackground (BLACK);
    writeln (url);
    writeln;

    ultimaTocada := url;
    if pos ('FFMPEG ', uppercase(r)) <> 1 then
        tocaRadioBass (url)
    else
        tocaRadioExterna (copy (url, 8, 999));
end;

{--------------------------------------------------------}
{                 folheia as preferidas
{--------------------------------------------------------}

procedure folheiaPreferidas;

var
    sites: array [1..20] of string;

    {--------------------------------------------------------}

    procedure removeItemPreferido (n: integer);
    var c: char;
        sn: string;
    begin
        clrscr;
        textBackground (BLUE);
        writeln ('PREFERIDAS');
        textBackground (BLACK);
        writeln;
        mensagem ('RDCNFRMI', 0);   {'Confirma remoo do item '}
        sintWriteInt (n);
        write (' ');
        c := popupMenuPorLetra('SN');
        if c = 'S' then
            begin
                limpabaixo (3);
                sintClek; sintClek;
                sites[n] := '';
                sn := intToStr(n);
                sintRemoveAmbienteArq('PREFERIDAS', sn, arqIndice);
                folheiaAltera(n, sn + ' - ');
            end;
    end;

    {--------------------------------------------------------}

    procedure editaItemPreferido (n: integer);
    var r, s, nomeRadio, sn, site: string;
        p: integer;
        c: char;
    begin
        clrscr;
        textBackground (BLUE);
        writeln ('PREFERIDAS');
        textBackground (BLACK);
        writeln;

        r := sintAmbienteArq ('PREFERIDAS', intToStr(n), '', arqIndice);
        nomeRadio := '';
        site := '';

        p := pos ('=', r);
        if p > 1 then
            begin
                nomeRadio := copy (r, 1, p-1);
                site := copy (r, p+1, 999);
                if copy (site, 1, 7) = 'FFMPEG ' then
                    delete (site, 1, 7);
            end;

        mensagem ('RDEDNOMR', 1);  {'Editore o nome da rdio: '}
        c := sintEdita(nomeRadio, wherex, wherey, 50, true);
        writeln (nomeRadio);
        if c = ESC then
             exit;
        mensagem ('RDEDENDR', 1);  {'Editore o endereo de acesso da rdio: '}
        c := sintEdita(site, wherex, wherey, 120, true);
        writeln (site);
        if c = ESC then
             exit;
        mensagem ('RDUSAPGX', 0);  {'Usa programa externo para acesso: '}
        c := popupMenuPorLetra ('SN');
        if c = ESC then
             exit;

        s := trim (nomeRadio) + '=';
        if c = 'S' then s := s + 'FFMPEG ';
        s := s + site;

        sn := intToStr(n);
        sintGravaAmbienteArq ('PREFERIDAS', sn, s, arqIndice);
        folheiaAltera(n, sn + ' - ' + nomeRadio);
        delete (s, 1, pos('=', s));
        sites[n] := s;
    end;

    {--------------------------------------------------------}

    procedure clonaItemPreferido (n: integer);
    var r, s, sn, nomeRadio: string;
        n2, p: integer;
        erro: integer;
    begin
        clrscr;
        textBackground (BLUE);
        writeln ('PREFERIDAS');
        textBackground (BLACK);
        writeln;

        r := sintAmbienteArq ('PREFERIDAS', intToStr(n), '', arqIndice);

        mensagem ('RDONDCLN', 0);   {'Informe o nmero em que ser clonado (de 1 a 20): }
        sintReadln (s);
        val (s, n2, erro);
        if erro <> 0 then
             begin
                 mensagem ('RDNUMINV', 2);    {'Nmero invlido'}
                 while sintFalando do waitMessage;
                 exit;
             end;

        sn := intToStr(n2);
        sintGravaAmbienteArq ('PREFERIDAS', sn, r, arqIndice);

        nomeRadio := r;
        p := pos ('=', nomeRadio);
        delete (nomeRadio, p, 999);
        folheiaAltera(n2, sn + ' - ' + nomeRadio);

        sites[n2] := sites[n];

        mensagem ('RDOK', 2);   {'OK'}
    end;

    {--------------------------------------------------------}

var
    radioSelecionada: string;
    n: integer;
    r: string;
    c, c2: char;
    nomesRadios: array [1..20] of string;
    nomeRadio: string;

    procedure renovaNomes;
    var i, p: integer;
    begin
        for i := 1 to 20 do
            begin
                sites [i] := '';
                r := sintAmbienteArq ('PREFERIDAS', intToStr(i), '', arqIndice);
                p := pos ('=', r);
                if p <= 1 then
                    nomesRadios[i] := ''
                else
                    begin
                        nomesRadios[i] := copy (r, 1, p-1);
                        sites[i] := copy (r, p+1, 999);
                    end;
            end;
    end;

begin
    clrscr;
    textBackground (BLUE);
    mensagem ('RDFOLPRF', 1);  {'Folheando as rdios preferidas.  F1 ajuda'}
    textBackground (BLACK);

    folheiaCria (wherex, wherey, 80, wherey+20);
    renovaNomes;
    for n := 1 to 20 do
        folheiaAdiciona(intToStr(n) + ' - ' + nomesRadios[n]);

    n := 1;
    radioSelecionada := '';

    limpaBufTec;
    repeat
        if folheiaExecuta(n, n, c, c2, true) then
            begin
                case upcase(c) of
                    ENTER:  begin
                                nomeRadio := nomesRadios[n];
                                radioSelecionada := sites[n];
                                break;
                            end;

                'R', F7: removeItemPreferido (n);
                    'E': editaItemPreferido (n);
                    'C': clonaItemPreferido (n);
                    ESC: ;
                else
                    gotoxy (1, 25);
                    mensagem ('RDREDENT', 0); {'As opes so: R-remove, E-edita, C-Clona, Enter: Toca.'}
                    while sintFalando do waitMessage;
                end;
                renovaNomes;
            end
        else
            c := ESC;

    until c = ESC;

    folheiaDestroi;

    if radioSelecionada <> '' then
        begin
            clrScr;
            TextBackground (BLUE);
            writeln (nomeRadio);
            TextBackground (BLACK);
            writeln;
            
            ultimaTocada := radioSelecionada;
            if pos ('FFMPEG ', uppercase(radioSelecionada)) <> 1 then
                tocaRadioBass (radioSelecionada)
            else
                tocaRadioExterna (copy (radioSelecionada, 8, 999));
        end;
end;

{--------------------------------------------------------}
{              repete a ltima escutada
{--------------------------------------------------------}

procedure ultimaEscutada;
begin
    clrscr;
    TextBackground (BLUE);
    writeln (ultimaTocada);
    TextBackground (BLACK);
    writeln;

    if pos ('FFMPEG ', uppercase(ultimaTocada)) <> 1 then
        tocaRadioBass (ultimaTocada)
    else
        tocaRadioExterna (copy (ultimaTocada, 8, 999));
end;

{--------------------------------------------------------}
{                        ajuda
{--------------------------------------------------------}

procedure ajudaOpcao;
begin
    writeln;
    mensagem ('RDOPCAO', 1);  {'As opes so:'}
    mensagem ('RDOPP_F', 1);  {'F - folheia as preferidas'}
    mensagem ('RDOPP_P', 1);  {'P - escolhe pelo nmero da preferida'}
    mensagem ('RDOPP_U', 1);  {'U - ltima rdio escutada'}
    mensagem ('RD_ESC' , 1);  {'ESC - terminar'}

    while keypressed do readkey;
    sintBip;
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

var n: integer;
const
    tabLetrasOpcao: string = 'FPU' + ESC;

begin
    garanteEspacoTela (5);
    popupMenuCria (wherex, wherey, 50, length(tabLetrasOpcao), MAGENTA);
    menuAdiciona ('RDOPP_F');  {'F - folheia as preferidas'}
    menuAdiciona ('RDOPP_P');  {'P - escolhe pelo nmero da preferida'}
    menuAdiciona ('RDOPP_U');  {'U - ltima rdio escutada'}
    menuAdiciona ('RD_ESC' );  {'ESC - terminar'}
    n := popupMenuSeleciona;
    if n > 0 then
        begin
            selSetasOpcao := tabLetrasOpcao[n];
            writeln (tabLetrasOpcao[n]);
        end
    else
        selSetasOpcao := ESC;
end;

{--------------------------------------------------------}
{             seleciona uma das rdios preferidas
{--------------------------------------------------------}

procedure radiosPreferidas;
var c, c2: char;
    opcao: string;
label fim;

begin
    while true do
        begin
            clrscr;
            textBackground (BLUE);
            writeln ('Radio 50 - Preferidas');
            writeln;

            textBackground (RED);
            mensagem ('RDPROQUE', 0);      {'Preferidas - que deseja? '}
            textBackground (BLACK);
            sintLeTecla (c, c2);
            opcao := '';

            if (c = #0) and ((c2 = CIMA) or (c2 = BAIX) or (c2 = F9)) then
                  begin
                      c := selSetasOpcao;
                      if c <> #$1b then
                          opcao := copy (
                             opcoesItemSelecionado, pos ('-', opcoesItemSelecionado)-1, 999);
                  end;

            if c = #$1b then
                begin
                    writeln;
                    goto fim;
                end;

            if (c = #0) and (c2 = F1) then
                 ajudaOpcao
            else
                 begin
                     clrscr;
                     textBackground (BLUE);
                     writeln ('Preferidas' + opcao);
                     textBackground (BLACK);
                     writeln;

                     case upcase(c) of
                         'F': folheiaPreferidas;
                         'P': escolhePeloNumero;
                         'U': ultimaEscutada;
                     else
                         mensagem ('RDOPINV', 1); {'Opo invlida'}
                     end;
                 end;
        end;
fim:
    writeln;
end;

end.

